// $Id: observer0.h,v 1.1 2001/07/14 18:20:02 dvermeir Exp $
// Example template definition from p. 262.
// A more general definition that supports heterogeneous
// observers can be found in observer1.h.

#ifndef	OBSERVER_H
#define	OBSERVER_H

#include	<list>
#include	<functional>
#include	<algorithm>

// An Observable has a number of associated Observers that will be
// warned using Observer::notified() each time the Observable changes
// state.
template<class Observer>
class Observable { 
public:
  void	add_observer(Observer& observer) { observers_.push_back(&observer); }
  void	remove_observer(Observer& observer) { observers_.remove(&observer); }
protected: // an observable that changes state will call notify()
  void	notify() { 
    for_each(observers_.begin(), observers_.end(), mem_fun(&Observer::notified)); 
    }
private:
  list<Observer*>		observers_;
};
#endif
