// $Id: product0.C,v 1.1 2001/07/14 18:07:56 dvermeir Exp $
// Example program from p. 253.
// A more powerful and easier version is in product1.C

#include <iostream>
#include <string>
#include <stdexcept> // for standard exception classes

#include "cstr2double.h"

// product: write product of arg1, arg2, arg3

static const string	USAGE("usage: product number number number");

int
main(int argc,char* argv[]) { 
try {
  if (argc!=4) 
    throw runtime_error(USAGE);
  double	a1(cstr2double(argv[1]));
  double	a2(cstr2double(argv[2]));
  double	a3(cstr2double(argv[3]));
  cout << a1*a2*a3 << endl;
  return 0;
  }
catch (exception& e) { // must be reference to preserve e's ``real'' type
  cerr << e.what() << endl;
  return 1; // error return
  }
}
