// $Id: product1.C,v 1.1 2001/07/14 18:07:56 dvermeir Exp $
// Example program from p. 254.
// Here we use more abstractions (transform, vector)
// to make the program more powerful and easier to
// uderstand.

#include <iostream>
#include <string>
#include <stdexcept> // for standard exception classes
#include <algorithm> // for transform
#include <numeric> // for accumulate
#include <vector>

#include "cstr2double.h"

// product: write product of command line arguments
static const string	USAGE("usage: product number..");

int
main(int argc,char* argv[]) { 
try {
  vector<double> args(argc-1);
  transform(argv+1,argv+argc,args.begin(),cstr2double);
  cout << accumulate(args.begin(), args.end(), 1.0 , multiplies<double>()) << endl;
  return 0;
  }
catch (exception& e) { // must be reference to preserve e's ``real'' type
  cerr << e.what() << endl;
  return 1; // error return
  }
}
