// $Id: quotient3.C,v 1.1 2001/07/14 18:07:57 dvermeir Exp $
// Example program from p. 245.
// The use of abstraction is less effective than
// in quotient2.C

// quotient: write quotient of arg1 and arg2 on stdout.
#include <string>
#include <iostream>
#include <stdlib.h> // for strtod(char*,char**)

static const string	USAGE("quotient number number");
static const string	FORMAT_ERROR("not a number");
static const string	DIVISION_BY_ZERO("cannot divide by 0");

bool
get_arguments(char* args[],double& arg1,double& arg2) {
char *end; // see the man page for strtod
arg1 = strtod(args[0],&end);
if (end==args[1]) {
  cerr << "\"" << args[0] << "\": " << FORMAT_ERROR << endl;
  return false;
  }
arg2 = strtod(args[1],&end);
if (end==args[1]) {
  cerr << "\"" << args[1] << "\": " << FORMAT_ERROR << endl;
  return false;
  }
return true;
}

int
main(int argc,char* argv[]) { 
if (argc!=3) {
  cerr << "usage: " << USAGE << endl; 
  return 1; // program failed
  }
double a1;
double a2;
if (!get_arguments(argv+1,a1,a2))
  return 1; // program failed
if (a2==0) {
  cerr << DIVISION_BY_ZERO << endl;
  return 1; // program failed
  }
cout << a1/a2 << endl;
return 0;
}
