// $Id: tobserver0.C,v 1.1 2001/07/15 13:45:41 dvermeir Exp $
// Example program from p. 263.
// A trivial illustration of the observer pattern.

#include "observer0.h"

class Model; // forward declaration
class ModelObserver {
public:
  ModelObserver(Model& m);
  void notified();
private:
  Model*	m_;
};

class Model: public Observable<ModelObserver> {
public:
  Model(int i=0): data_(i) {}
  int data() const { return data_; }
  Model& update(int i) { data_ = i; notify(); return *this; }
private:
  int	data_;
};

// definitions of ModeObserver's member functions
ModelObserver::ModelObserver(Model& m): m_(&m) { m_->add_observer(*this); }
void  ModelObserver::notified() { cout << "observation: " << m_->data() << endl; }

int
main() {
Model		m;
ModelObserver	observer(m);
m.update(5);  // prints "observation: 5"
}
