// $Id: tobserver1.C,v 1.1 2001/07/15 13:45:41 dvermeir Exp $
// Example program from p. 263.
// A trivial illustration of the heterogeneous observer solution.

#include "observer1.h"

class Model: public Observable {
public:
  Model(int i=0): data_(i) {}
  int data() const { return data_; }
  Model& update(int i) { data_ = i; notify(); return *this; }
private:
  int	data_;
};

// ModelObserver A
class ModelObserverA {
public:
  ModelObserverA(Model& m);
  void notified();
private:
  Model*	m_;
};

// definitions of ModeObserverA's member functions
ModelObserverA::ModelObserverA(Model& m): m_(&m) { 
m_->add_observer(*this); 

}
void  
ModelObserverA::notified() { 
cout << "A-observation: " << m_->data() << endl;
}

// ModelObserver B
class ModelObserverB {
public:
  ModelObserverB(Model& m);
  void notified();
private:
  Model*	m_;
};

// definitions of ModeObserverA's member functions
ModelObserverB::ModelObserverB(Model& m): m_(&m) { 
m_->add_observer(*this); 

}
void  
ModelObserverB::notified() { 
cout << "B-observation: " << m_->data() << endl;
}


int
main() {
Model		m;
ModelObserverA	observera(m);
ModelObserverB	observerb(m);
m.update(5);  // prints "observation: 5"
}
